GDCM 2.2.1

- Main Page
- Related Pages
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
gdcm::Image Class Reference

Image This is the container for an Image in the general sense. From this container you should be able to request information like: More...

`#include <gdcmImage.h>`

Inheritance diagram for gdcm::Image:
[legend]
Collaboration diagram for gdcm::Image:
[legend]

## Public Member Functions

| Image ()
| ~Image ()
const double * | GetDirectionCosines () const
double | GetDirectionCosines (unsigned int idx) const
double | GetIntercept () const
const double * | GetOrigin () const
double | GetOrigin (unsigned int idx) const
double | GetSlope () const
const double * | GetSpacing () const
double | GetSpacing (unsigned int idx) const
void | Print (std::ostream &os) const
| print
void | SetDirectionCosines (const float *dircos)
void | SetDirectionCosines (const double *dircos)
void | SetDirectionCosines (unsigned int idx, double dircos)
void | SetIntercept (double intercept)
| intercept
void | SetOrigin (const float *ori)
void | SetOrigin (const double *ori)
void | SetOrigin (unsigned int idx, double ori)
void | SetSlope (double slope)
| slope
void | SetSpacing (const double *spacing)
void | SetSpacing (unsigned int idx, double spacing)
Public Member Functions inherited from gdcm::Pixmap
| Pixmap ()
| ~Pixmap ()
bool | AreOverlaysInPixelData () const
| returns if Overlays are stored in the unused bit of the pixel data:
Curve & | GetCurve (unsigned int i=0)
| Curve: group 50xx.
const Curve & | GetCurve (unsigned int i=0) const
const IconImage & | GetIconImage () const
| Set/Get Icon Image.
IconImage & | GetIconImage ()
size_t | GetNumberOfCurves () const
size_t | GetNumberOfOverlays () const
Overlay & | GetOverlay (size_t i=0)
| Overlay: group 60xx.
const Overlay & | GetOverlay (size_t i=0) const
void | Print (std::ostream &) const
void | RemoveOverlay (size_t i)
void | SetIconImage (IconImage const &ii)
void | SetNumberOfCurves (size_t n)
void | SetNumberOfOverlays (size_t n)
Public Member Functions inherited from gdcm::Bitmap
| Bitmap ()
| ~Bitmap ()
void | Clear ()
bool | GetBuffer (char *buffer) const
| Acces the raw data.
unsigned long | GetBufferLength () const
unsigned int | GetColumns () const
const DataElement & | GetDataElement () const
DataElement & | GetDataElement ()
unsigned int | GetDimension (unsigned int idx) const
const unsigned int * | GetDimensions () const
| Return the dimension of the pixel data, first dimension (x), then 2nd (y), then 3rd (z)...
const LookupTable & | GetLUT () const
LookupTable & | GetLUT ()
bool | GetNeedByteSwap () const
unsigned int | GetNumberOfDimensions () const
| Return the number of dimension of the pixel data bytes; for example 2 for a 2D matrices of values.
const PhotometricInterpretation & | GetPhotometricInterpretation () const
| return the photometric interpretation
const PixelFormat & | GetPixelFormat () const
| Get/Set PixelFormat.
PixelFormat & | GetPixelFormat ()
unsigned int | GetPlanarConfiguration () const
| return the planar configuration
unsigned int | GetRows () const
const TransferSyntax & | GetTransferSyntax () const
bool | IsEmpty () const
bool | IsLossy () const
| Return whether or not the image was compressed using a lossy compressor or not.
bool | IsTransferSyntaxCompatible (TransferSyntax const &ts) const
void | SetColumns (unsigned int col)
void | SetDataElement (DataElement const &de)
void | SetDimension (unsigned int idx, unsigned int dim)
void | SetDimensions (const unsigned int dims[3])
void | SetLossyFlag (bool f)
| Specifically set that the image was compressed using a lossy compression mechanism.
void | SetLUT (LookupTable const &lut)
| Set/Get LUT.
void | SetNeedByteSwap (bool b)
void | SetNumberOfDimensions (unsigned int dim)
void | SetPhotometricInterpretation (PhotometricInterpretation const &pi)
void | SetPixelFormat (PixelFormat const &pf)
void | SetPlanarConfiguration (unsigned int pc)
void | SetRows (unsigned int rows)
void | SetTransferSyntax (TransferSyntax const &ts)
| Transfer syntax.
Public Member Functions inherited from gdcm::Object
| Object ()
| Object (const Object &)
| Special requirement for copy/cstor, assigment operator.
virtual | ~Object ()
void | operator= (const Object &)

## Additional Inherited Members

Protected Types inherited from gdcm::Bitmap
typedef SmartPointer< LookupTable > | LUTPtr
Protected Member Functions inherited from gdcm::Bitmap
bool | ComputeLossyFlag ()
bool | GetBuffer2 (std::ostream &os) const
bool | TryJPEG2000Codec (char *buffer, bool &lossyflag) const
bool | TryJPEG2000Codec2 (std::ostream &os) const
bool | TryJPEGCodec (char *buffer, bool &lossyflag) const
bool | TryJPEGCodec2 (std::ostream &os) const
bool | TryJPEGLSCodec (char *buffer, bool &lossyflag) const
bool | TryKAKADUCodec (char *buffer, bool &lossyflag) const
bool | TryPVRGCodec (char *buffer, bool &lossyflag) const
bool | TryRAWCodec (char *buffer, bool &lossyflag) const
bool | TryRLECodec (char *buffer, bool &lossyflag) const
Protected Attributes inherited from gdcm::Pixmap
std::vector< Curve > | Curves
SmartPointer< IconImage > | Icon
std::vector< Overlay > | Overlays

## Detailed Description

Image This is the container for an Image in the general sense. From this container you should be able to request information like:

- Origin
- Dimension
- PixelFormat ... But also to retrieve the image as a raw buffer (char *) Since we have to deal with both RAW data and JPEG stream (which internally encode all the above information) this API might seems redundant. One way to solve that would be to subclass gdcm::Image with gdcm::JPEGImage which would from the stream extract the header info and fill it to please gdcm::Image...well except origin for instance

Basically you can see it as a storage for the Pixel Data element (7fe0,0010).

Warning
  This class does some heuristics to guess the Spacing but is not compatible with DICOM CP-586. In case of doubt use PixmapReader instead

See Also
  ImageReader PixmapReader

Examples:
  CompressImage.cxx, ConvertToQImage.cxx, CreateARGBImage.cxx, CreateCMYKImage.cxx, csa2img.cxx, ExtractIconFromFile.cxx, FixJAIBugJPEGLS.cxx, GenFakeImage.cxx, GetJPEGSamplePrecision.cxx, GetSubSequenceData.cxx, HelloVizWorld.cxx, iU22tomultisc.cxx, PatchFile.cxx, ReadMultiTimesException.cxx, and threadgdcm.cxx.

## Constructor & Destructor Documentation

gdcm::Image::Image | ( |  | ) |

inline

gdcm::Image::~Image | ( |  | ) |

inline

## Member Function Documentation

const double* gdcm::Image::GetDirectionCosines | ( |  | ) | const

Return a 6-tuples specifying the direction cosines A default value of (1,0,0,0,1,0) will be return when the direction cosines was not specified.

double gdcm::Image::GetDirectionCosines | ( | unsigned int | idx | ) | const

double gdcm::Image::GetIntercept | ( |  | ) | const

inline

const double* gdcm::Image::GetOrigin | ( |  | ) | const

Return a 3-tuples specifying the origin Will return (0,0,0) if the origin was not specified.

Examples:
  HelloVizWorld.cxx.

double gdcm::Image::GetOrigin | ( | unsigned int | idx | ) | const

double gdcm::Image::GetSlope | ( |  | ) | const

inline

const double* gdcm::Image::GetSpacing | ( |  | ) | const

Return a 3-tuples specifying the spacing NOTE: 3rd value can be an aribtrary 1 value when the spacing was not specified (ex. 2D image). WARNING: when the spacing is not specifier, a default value of 1 will be returned

double gdcm::Image::GetSpacing | ( | unsigned int | idx | ) | const

void gdcm::Image::Print | ( | std::ostream & | os | ) | const

virtual

print

Reimplemented from gdcm::Bitmap.

Examples:
  CompressImage.cxx, and PatchFile.cxx.

void gdcm::Image::SetDirectionCosines | ( | const float * | dircos | ) |

void gdcm::Image::SetDirectionCosines | ( | const double * | dircos | ) |

void gdcm::Image::SetDirectionCosines | ( | unsigned int | idx,
|  | double | dircos
| ) |  |

void gdcm::Image::SetIntercept | ( | double | intercept | ) |

inline

intercept

void gdcm::Image::SetOrigin | ( | const float * | ori | ) |

void gdcm::Image::SetOrigin | ( | const double * | ori | ) |

void gdcm::Image::SetOrigin | ( | unsigned int | idx,
|  | double | ori
| ) |  |

void gdcm::Image::SetSlope | ( | double | slope | ) |

inline

slope

void gdcm::Image::SetSpacing | ( | const double * | spacing | ) |

Examples:
  csa2img.cxx, and iU22tomultisc.cxx.

void gdcm::Image::SetSpacing | ( | unsigned int | idx,
|  | double | spacing
| ) |  |

The documentation for this class was generated from the following file:

- gdcmImage.h